/**
 * The state of the app.
 */
export declare enum AppState {
    /**
     * The app is not running.
     */
    IDLE = "idle",
    /**
     * The app is running to update DOM.
     */
    UPDATE = "update",
    /**
     * The app is running to receive events.
     */
    RECV = "recv"
}
declare global {
    interface ImportMetaEnv {
        /**
         * Whether the app is running in development mode.
         *
         * In development mode, Refina will print detailed runtime information to the console,
         *  and extra checks will be performed to ensure the app is running correctly.
         */
        DEV: boolean;
    }
    interface ImportMeta {
        readonly env: ImportMetaEnv;
    }
}
//# sourceMappingURL=constants.d.ts.map