import { App } from "../app";
import { Content } from "../dom";
import { ContextFuncs, IntrinsicBaseContext } from "./base";
export interface IntrinsicRecvContext extends IntrinsicBaseContext {
    $lowlevel: IntrinsicRecvContext;
    /**
     * Is the event received?
     */
    $received: boolean;
    /**
     * Process DOM element component in `RECV` state.
     *
     * @param ckey The Ckey of the element.
     * @param content The content of the DOM element component.
     */
    $$processDOMElement(ckey: string, content?: Content): void;
}
/**
 * The full context type in `RECV` state, with context funcs.
 */
export type RecvContext = Readonly<Omit<IntrinsicRecvContext, `$$${string}`>> & ContextFuncs;
/**
 * Initialize a context in `RECV` state.
 *
 * @param app The app instance.
 * @param receiver The receiver of the event.
 * @param event The event data.
 */
export declare function initializeRecvContext(app: App): void;
//# sourceMappingURL=recv.d.ts.map