import { DOMElementComponent } from "./element";
import { DOMNodeComponent, MaybeChildNode } from "./node";
export declare class DOMPortalComponent extends DOMElementComponent {
    /**
     * Children to be removed when update mount.
     */
    protected childrenToRemove: Set<DOMNodeComponent>;
    updateDOM(): null;
    /**
     * Update the DOM tree of the portal.
     *
     * @param lastNode The last updated node.
     * @returns the new last updated node.
     */
    updateMount(lastNode: MaybeChildNode): MaybeChildNode;
    /**
     * Remove the portal from the DOM tree.
     */
    unmount(): void;
    addEventListener(_event: unknown, _listener: unknown, _options: unknown): never;
    addEventListeners(_listeners: unknown): never;
    addCls(_classes: string): never;
    addCss(_style: string): never;
    addAttrs(_attrs: Partial<this["node"]>): never;
    get asChildNode(): null;
    insertAfter(_node: ChildNode): void;
    prependTo(_parent: Element): void;
    removeFrom(_parent: Element): void;
}
//# sourceMappingURL=portal.d.ts.map