import { HTMLElementComponent } from "./element";
import { MaybeChildNode } from "./node";
import { DOMPortalComponent } from "./portal";
/**
 * The root component of the app.
 *
 * There should be only one root component,
 *  representing the element with id passed too the `App` constructor.
 *
 * This component manages top-level components of the app and portals.
 */
export declare class DOMRootComponent extends HTMLElementComponent<keyof HTMLElementTagNameMap> {
    /**
     * Portals that have not been updated to the DOM tree.
     */
    pendingPortals: DOMPortalComponent[];
    /**
     * Portals that is currently mounted to the DOM tree.
     */
    protected mountedPortals: Set<DOMPortalComponent>;
    addEventListener<K extends keyof HTMLElementEventMap>(type: K & string, listener: (this: HTMLAnchorElement, ev: HTMLElementEventMap[K]) => void, options?: boolean | AddEventListenerOptions): void;
    updateDOM(): MaybeChildNode;
    insertAfter(_node: ChildNode): never;
    prependTo(_parent: Element): never;
    removeFrom(_parent: Element): never;
}
//# sourceMappingURL=root.d.ts.map