import { DOMElementComponent } from "./element";
/**
 * The window component that manages event listeners of Window.
 *
 * **Note**: Window is not a DOM element in fact,
 *  but we just treat it as a DOM element to reuse the code to manage event listeners.
 */
export declare class DOMWindowComponent extends DOMElementComponent<any> {
    updateDOM(): null;
    addCls(_classes: string): void;
    addCss(_style: string): void;
    addAttrs(_attrs: Partial<this["node"]>): void;
    insertAfter(_node: ChildNode): never;
    prependTo(_parent: Element): never;
    removeFrom(_parent: Element): never;
}
//# sourceMappingURL=window.d.ts.map