var u = /* @__PURE__ */ ((r) => (r.IDLE = "idle", r.UPDATE = "update", r.RECV = "recv", r))(u || {});
class C {
  constructor() {
    this.$app = a.$app, this.$updateModel = a.$app.updateModel;
  }
  /**
   * The app that the component is installed on.
   */
  $app;
  /**
   * The ref tree node of the component.
   */
  $refTreeNode = {};
  /**
   * The primary element of the component.
   * If the component does not have a `HTMLElement` or `SVGElement`, it is `undefined`.
   * Set with `this.$main()` or be the first element of the component by default.
   */
  $primaryEl;
  /**
   * Call this method to set the next element as the primary element of this component.
   */
  $primary() {
    a.$updateContext?.$lowlevel.$$pendingPrimaryElOwner.push(this);
  }
  /**
   * Trigger an `UPDATE` call.
   */
  $update() {
    this.$app.update();
  }
  /**
   * Set the value of a model and trigger an `UPDATE` call if the value is changed.
   *
   * @param model The model.
   * @param v The new value.
   * @returns Whether the value is changed.
   */
  $updateModel;
}
function N(r) {
  return "prototype" in r && r.prototype instanceof C;
}
function b(r, e) {
  return function(t, ...n) {
    return a.$$processComponent(
      t,
      e,
      n,
      r
    );
  };
}
class ce extends C {
  $_fired = !1;
  $_firedData;
  /**
   * Fire an event with data.
   *
   * @param data The data of the event.
   */
  $fire = (e) => {
    this.$_fired = !0, this.$_firedData = e, this.$app.recv();
  };
  /**
   * Create a function that fires an event with data.
   *
   * @param data The data of the event.
   * @returns A function that fires the event.
   */
  $fireWith = (e) => () => this.$fire(e);
  get $fired() {
    return a.$recvContext && this.$_fired ? (this.$_fired = !1, a.$ev = this.$_firedData, !0) : !1;
  }
}
function M(r) {
  const e = a;
  e._ = e, e.$app = r, e.$root = r.root, e.$body = r.body, e.$window = r.window, e.$appState = r.state, e.$lowlevel = e, e.$runtimeData = {}, e.$$currentRefNode = r.root.$refTreeNode, e.$$processedComponents = /* @__PURE__ */ new Set(), e.$$d = (t, n) => {
    if (n != null) {
      if (typeof n == "function")
        return N(n) ? (...s) => e.$$processComponent(t, n, s, n.name) : n(t, r);
      if (typeof n == "symbol" || String(n)[0] === "$") {
        const s = e[n];
        return typeof s == "function" ? s.bind(e) : s;
      } else
        return n === "t" ? (...s) => {
          e.$$t(
            t,
            Array.isArray(s[0]) ? String.raw({ raw: s[0] }, ...s.slice(1)) : s[0]
          );
        } : (...s) => {
          e.$$c(t, n, ...s);
        };
    }
  };
}
function pe() {
  const r = a;
  r.$app = null, r.$appState = null, r.$lowlevel = null, r.$$currentRefNode = null, r.$runtimeData = null, r.$$processedComponents = null, r.$root = null, r.$body = null, r.$window = null;
  const e = () => {
    console.warn("This context is cleared!");
  };
  r.$props = e, r.$cls = e, r.$css = e, r.$ref = e, r.$$assertEmpty = e, r.$$d = e, r.$$c = e, r.$$t = e;
}
function ue(r) {
  return r;
}
const a = {};
function L() {
  const r = {}, e = {};
  let t = !1, n = "", s = !1, o = "";
  const i = {};
  return {
    setProps(l) {
      return Object.assign(r, l), this;
    },
    setAttrs(l) {
      return Object.assign(e, l), this;
    },
    addCls(l) {
      return n += l + " ", this;
    },
    resetCls(l) {
      return t = !0, n = l + " ", this;
    },
    addCss(l) {
      return o += l + ";", this;
    },
    resetCss(l) {
      return s = !0, o = l + ";", this;
    },
    addEventListener(l, c, d) {
      return i[l] = { listener: c, options: d }, this;
    },
    get patchData() {
      return {
        props: r,
        attrs: e,
        resetCls: t,
        cls: n,
        resetCss: s,
        css: o,
        eventListeners: i
      };
    }
  };
}
const f = function() {
  return this;
}, _ = {
  setProps: f,
  setAttrs: f,
  addCls: f,
  resetCls: f,
  addCss: f,
  resetCss: f,
  addEventListener: f,
  get patchData() {
    throw new Error("emptyPatchTarget");
  }
};
function T(r) {
  M(r);
  const e = a;
  e.$updateContext = null, e.$recvContext = e, e.$received = !1, e.$ref = e.$props = e.$cls = e.$css = e.$id = e.$attrs = () => !0, e.$patch = () => _, e.$$assertEmpty = () => {
  }, e.$$c = (t, n, ...s) => {
    if (n[0] === "_") {
      if (e.$received)
        return;
      const [i, l, c] = s;
      e.$$processDOMElement(t, l);
      return;
    }
    return e.$app.contextFuncs[n].call(e.$lowlevel, t, ...s);
  }, e.$$t = (t, n) => {
  }, e.$$processDOMElement = (t, n) => {
    if (typeof n == "function") {
      const s = e.$$currentRefNode[t];
      if (s) {
        const o = e.$$currentRefNode;
        e.$$currentRefNode = s.$refTreeNode;
        try {
          n(e._);
        } catch (i) {
          e.$app.callHook("onError", i);
        }
        e.$$currentRefNode = o;
      }
    }
  }, e.$$processComponent = (t, n, s, o) => {
    let i = e.$$currentRefNode[t];
    const l = e.$$currentRefNode;
    i || (i = new n(), l[t] = i), e.$$currentRefNode = i.$refTreeNode;
    const c = i.$main(...s);
    return e.$$currentRefNode = l, c;
  }, r.callHook("initContext", e);
}
const w = Symbol("toModelValue");
function H(r) {
  return {
    value: r,
    [w]() {
      return this.value;
    },
    [Symbol.toPrimitive]() {
      return this.value;
    }
  };
}
function S(r) {
  return r?.[w];
}
function F(r, e) {
  return S(r) && r.value !== e ? (r.value = e, !0) : !1;
}
function $e(r) {
  return r[w]?.() ?? r;
}
function fe(r, e) {
  return {
    obj: r,
    key: e,
    get value() {
      return this.obj[this.key];
    },
    set value(t) {
      this.obj[this.key] = t;
    },
    [w]() {
      return this.value;
    },
    [Symbol.toPrimitive]() {
      return this.value;
    }
  };
}
function he(r = null) {
  return { current: r };
}
function k(...r) {
  return {
    mergedCurrent: null,
    get current() {
      return this.mergedCurrent;
    },
    set current(e) {
      this.mergedCurrent = e, r.forEach((t) => {
        t.current = e;
      });
    }
  };
}
function me(r = null) {
  return { current: r };
}
function Ce(r = null) {
  return { current: r };
}
class O {
  /**
   * @param node The DOM node of this component.
   */
  constructor(e) {
    this.node = e;
  }
  /**
   * The node for the parent DOM element to manage.
   */
  get asChildNode() {
    return this.node;
  }
  /**
   * Insert the DOM node after the given element.
   *
   * @param node The element to insert after.
   */
  insertAfter(e) {
    e.after(this.node);
  }
  /**
   * Prepend the DOM node to the parent DOM element.
   *
   * @param parent The parent DOM element to prepend to.
   */
  prependTo(e) {
    e.prepend(this.node);
  }
  /**
   * Remove the DOM node from its parent.
   *
   * @param parent The parent DOM element to remove from.
   */
  removeFrom(e) {
    e.removeChild(this.node);
  }
}
class v extends O {
  /**
   * The ref tree node of this element.
   */
  $refTreeNode = {};
  /**
   * The primary element of the component.
   *
   * In common cases, this is the same as `this`.
   */
  $primaryEl = this;
  /**
   * Children DOM node components that are not updated to the DOM tree yet.
   */
  pendingChildren = [];
  /**
   * Children DOM node components that have mounted to the DOM tree.
   */
  mountedChildren = /* @__PURE__ */ new Set();
  updateDOM() {
    this.applyAttrs(), this.applyCls(), this.applyCss(), this.applyEventListeners();
    let e = new Set(this.mountedChildren), t = null;
    for (const n of this.pendingChildren)
      n.updateDOM(), this.mountedChildren.has(n) ? e.delete(n) : t ? n.insertAfter(t) : n.prependTo(this.node), t = n.asChildNode ?? t;
    for (const n of e)
      n.removeFrom(this.node);
    return this.mountedChildren = new Set(this.pendingChildren), this.pendingChildren = [], t;
  }
  /**
   * The attributes that are not applied yet.
   *
   * It can accumulate attributes from multiple calls of `addAttr` during the `UPDATE` call.
   */
  pendingAttrs = {};
  /**
   * Add a attributes to the element.
   *
   * @param attrs The attributes to add.
   */
  addAttrs(e) {
    Object.assign(this.pendingAttrs, e);
  }
  /**
   * The attributes that are applied to the DOM element.
   */
  appliedAttrs = {};
  /**
   * Write the pending attributes to the DOM element.
   */
  applyAttrs() {
    throw new Error("Not implemented.");
  }
  /**
   * The classes that are not applied yet.
   *
   * It can accumulate classes from multiple calls of `addCls` during the `UPDATE` call.
   */
  pendingCls = "";
  /**
   * Append classes to the element.
   *
   * @param cls The classes to add.
   */
  addCls(e) {
    this.pendingCls += e;
  }
  /**
   * The classes that are applied to the DOM element.
   */
  appliedCls = "";
  /**
   * Write the pending classes to the DOM element.
   */
  applyCls() {
    this.appliedCls !== this.pendingCls && (this.pendingCls === "" ? this.node.removeAttribute("class") : this.node.setAttribute("class", this.pendingCls), this.appliedCls = this.pendingCls), this.pendingCls = "";
  }
  /**
   * The styles that are not applied yet.
   *
   * It can accumulate styles from multiple calls of `addCss` during the `UPDATE` call.
   */
  pendingCss = "";
  /**
   * Append styles to the element.
   *
   * **Note**: It is not required to add a semicolon (`;`) at the end of the style.
   *
   * @param css The css to add.
   */
  addCss(e) {
    e !== "" && (this.pendingCss += e);
  }
  /**
   * The styles that are applied to the DOM element.
   */
  appliedCss = "";
  /**
   * Write the pending styles to the DOM element.
   */
  applyCss() {
    this.appliedCss !== this.pendingCss && (this.pendingCss === "" ? this.node.removeAttribute("style") : this.node.setAttribute("style", this.pendingCss), this.appliedCss = this.pendingCss), this.pendingCss = "";
  }
  /**
   * The event listeners that are not applied yet.
   *
   * It can accumulate event listeners from multiple calls of `addEventListener` during the `UPDATE` call.
   */
  pendingEventListeners = {};
  /**
   * The event listeners that are applied to the DOM element.
   */
  registeredEventListeners = {};
  /**
   * Add an event listener to the element.
   *
   * **Note**: The parameters of this method is the same as `addEventListener` of `HTMLElement`.
   *
   * @param type The event type.
   * @param listener The event listener.
   * @param options The event listener options.
   */
  addEventListener(e, t, n) {
    this.pendingEventListeners[e] ??= [], this.pendingEventListeners[e].push([t, n]);
  }
  /**
   * This method is used by `Context` to add the event listeners
   *  from the third argument of the DOM element component function.
   *
   * @param listeners The event listener map to add.
   */
  addEventListeners(e) {
    for (const t in e) {
      const n = e[t];
      this.pendingEventListeners[t] ??= [], typeof n == "function" ? this.pendingEventListeners[t].push([n]) : this.pendingEventListeners[t].push([
        n.listener,
        n.options
      ]);
    }
  }
  /**
   * Write the pending event listeners to the DOM element.
   */
  applyEventListeners() {
    const e = this.registeredEventListeners, t = this.pendingEventListeners;
    for (const n in e)
      for (const s of e[n])
        this.node.removeEventListener(n, ...s);
    for (const n in t)
      for (const s of t[n])
        this.node.addEventListener(n, ...s);
    this.registeredEventListeners = t, this.pendingEventListeners = {};
  }
}
class D extends v {
  applyAttrs() {
    for (const e in this.pendingAttrs) {
      const t = this.pendingAttrs[e];
      this.appliedAttrs[e] !== t && (t === void 0 ? delete this.node[e] : this.node[e] = t);
    }
    for (const e in this.appliedAttrs)
      e in this.pendingAttrs || delete this.node[e];
    this.appliedAttrs = this.pendingAttrs, this.pendingAttrs = {};
  }
}
class j extends v {
  applyAttrs() {
    for (const e in this.pendingAttrs) {
      const t = this.pendingAttrs[e];
      this.appliedAttrs[e] !== t && (t === void 0 ? this.node.removeAttribute(e) : typeof t == "function" ? this.node[e] = t : this.node.setAttribute(e, String(t)));
    }
    for (const e in this.appliedAttrs)
      e in this.pendingAttrs || this.node.removeAttribute(e);
    this.appliedAttrs = this.pendingAttrs, this.pendingAttrs = {};
  }
}
class U extends D {
  updateDOM() {
    return this.applyCls(), this.applyCss(), this.applyEventListeners(), null;
  }
  insertAfter(e) {
    throw new Error("Cannot insert body component after another node.");
  }
  prependTo(e) {
    throw new Error("Cannot prepend body component to DOM tree.");
  }
  removeFrom(e) {
    throw new Error("Cannot remove body component from DOM tree.");
  }
}
function we(r, ...e) {
  return typeof r == "function" ? () => r(...e) : r;
}
class q extends v {
  /**
   * Children to be removed when update mount.
   */
  childrenToRemove;
  updateDOM() {
    this.childrenToRemove = new Set(this.mountedChildren);
    for (const e of this.pendingChildren)
      e.updateDOM(), this.childrenToRemove.delete(e);
    return null;
  }
  /**
   * Update the DOM tree of the portal.
   *
   * @param lastNode The last updated node.
   * @returns the new last updated node.
   */
  updateMount(e) {
    for (const t of this.pendingChildren)
      this.mountedChildren.has(t) || (e ? t.insertAfter(e) : t.prependTo(this.node)), e = t.asChildNode ?? e;
    for (const t of this.childrenToRemove)
      t.removeFrom(this.node);
    return this.mountedChildren = new Set(this.pendingChildren), this.pendingChildren = [], e;
  }
  /**
   * Remove the portal from the DOM tree.
   */
  unmount() {
    for (const e of this.mountedChildren)
      e.removeFrom(this.node);
    this.mountedChildren = /* @__PURE__ */ new Set(), this.pendingChildren = [];
  }
  addEventListener(e, t, n) {
    throw new Error("Cannot add event listener to portal.");
  }
  addEventListeners(e) {
    throw new Error("Cannot add event listeners to portal.");
  }
  addCls(e) {
    throw new Error("Cannot add classes to portal.");
  }
  addCss(e) {
    throw new Error("Cannot add styles to portal.");
  }
  addAttrs(e) {
    throw new Error("Cannot add attrs to portal.");
  }
  get asChildNode() {
    return null;
  }
  insertAfter(e) {
  }
  prependTo(e) {
  }
  removeFrom(e) {
  }
}
class R extends D {
  /**
   * Portals that have not been updated to the DOM tree.
   */
  pendingPortals = [];
  /**
   * Portals that is currently mounted to the DOM tree.
   */
  mountedPortals = /* @__PURE__ */ new Set();
  addEventListener(e, t, n) {
    return super.addEventListener(e, t, n);
  }
  updateDOM() {
    let e = super.updateDOM();
    const t = this.mountedPortals;
    for (const n of this.pendingPortals)
      e = n.updateMount(e), t.delete(n);
    for (const n of t)
      n.unmount();
    return this.mountedPortals = new Set(this.pendingPortals), this.pendingPortals = [], e;
  }
  insertAfter(e) {
    throw new Error("Cannot insert root component after another node.");
  }
  prependTo(e) {
    throw new Error("Cannot prepend root component to DOM tree.");
  }
  removeFrom(e) {
    throw new Error("Cannot remove root component from DOM tree.");
  }
}
class I extends O {
  updateDOM() {
    return null;
  }
}
function ve(r) {
  return r;
}
class V extends v {
  updateDOM() {
    return this.applyEventListeners(), null;
  }
  addCls(e) {
    throw new Error("Cannot add classes to window.");
  }
  addCss(e) {
    throw new Error("Cannot add styles to window.");
  }
  addAttrs(e) {
    throw new Error("Cannot add attrs to window.");
  }
  insertAfter(e) {
    throw new Error("Cannot insert window component after another node.");
  }
  prependTo(e) {
    throw new Error("Cannot prepend window component to DOM tree.");
  }
  removeFrom(e) {
    throw new Error("Cannot remove window component from DOM tree.");
  }
}
function z(r, e) {
  if (!/^(>([a-z_][a-z0-9_]*|\*)(:(\d+|\*))?)+$/i.test(r))
    throw new Error(`Invalid selector: ${r}`);
  const t = r.split(">").slice(1);
  let n;
  for (let s = t.length - 1; s >= 0; s--) {
    const o = t[s], i = n ?? e, [l, c] = o.split(":");
    if (c === "*")
      l === "*" ? n = () => i : n = (d) => d === l && i;
    else {
      let d = c ? parseInt(c) : 1;
      l === "*" ? n = () => (d--, d === 0 ? i : !1) : n = ($) => $ !== l ? !1 : (d--, d === 0 ? i : !1);
    }
  }
  return () => n;
}
function K(r) {
  M(r);
  const e = a;
  e.$updateContext = e, e.$recvContext = null, e.$$pendingPrimaryElOwner = [], e.$$currentDOMParent = r.root, e.$$pendingPatches = [], e.$$nextRef = null, e.$$nextData = {
    props: {},
    attrs: {},
    cls: "",
    css: "",
    eventListeners: []
  }, e.$ref = (t, ...n) => (e.$$nextRef = n.length === 0 ? t : k(t, ...n), !0), e.$$fulfillRef = (t) => {
    e.$$nextRef !== null && (e.$$nextRef.current = t, e.$$nextRef = null);
  }, e.$$fulfillPrimaryEl = (t) => {
    for (const n of e.$$pendingPrimaryElOwner)
      n.$primaryEl = t;
    e.$$pendingPrimaryElOwner = [];
  }, e.$props = (t) => (Object.assign(e.$$nextData.props, t), !0), e.$cls = (...t) => (e.$$nextData.cls += (Array.isArray(t[0]) ? String.raw({ raw: t[0] }, ...t.slice(1)) : t[0]) + " ", !0), e.$css = (...t) => (e.$$nextData.css += (Array.isArray(t[0]) ? String.raw({ raw: t[0] }, ...t.slice(1)) : t[0]) + ";", !0), e.$id = (...t) => (e.$$nextData.attrs.id = Array.isArray(t[0]) ? String.raw({ raw: t[0] }, ...t.slice(1)) : t[0], !0), e.$attrs = (t) => (Object.assign(e.$$nextData.attrs, t), !0), e.$patch = (...t) => {
    const n = Array.isArray(t[0]) ? String.raw({ raw: t[0] }, ...t.slice(1)) : t[0], s = L();
    return e.$$pendingPatches.push(z(n, s)), s;
  }, e.$$fulfillPatches = (t) => {
    const n = e.$$pendingPatches.map((s) => s(t));
    return e.$$pendingPatches = n.filter(
      (s) => typeof s == "function"
    ), n.filter((s) => typeof s == "object");
  }, e.$$consumeNextData = (t) => {
    const n = {
      props: e.$$nextData.props,
      attrs: e.$$nextData.attrs,
      cls: e.$$nextData.cls,
      css: e.$$nextData.css,
      eventListeners: e.$$nextData.eventListeners
    };
    for (let s = t.length - 1; s >= 0; s--) {
      const o = t[s].patchData;
      Object.assign(n.props, o.props), Object.assign(n.attrs, o.attrs), o.resetCls ? n.cls = o.cls : n.cls += " " + o.cls, o.resetCss ? n.css = o.css : n.css += " " + o.css, Object.keys(o.eventListeners).length > 0 && n.eventListeners.push(o.eventListeners);
    }
    return e.$$nextData = {
      props: {},
      attrs: {},
      cls: "",
      css: "",
      eventListeners: []
    }, n;
  }, e.$$c = (t, n, ...s) => {
    if (n[0] === "_") {
      const [i, l, c] = s;
      let d = e.$$currentRefNode[t];
      if (!d)
        if (/^_svg[A-Z]/.test(n)) {
          const p = n[4].toLowerCase() + n.slice(5);
          d = new j(
            document.createElementNS("http://www.w3.org/2000/svg", p)
          ), e.$$currentRefNode[t] = d;
        } else {
          const p = n.slice(1), h = e.$app.htmlElementAlias[p] ?? p;
          d = new D(
            document.createElement(h)
          ), e.$$currentRefNode[t] = d;
        }
      const $ = e.$$pendingPatches, g = e.$$fulfillPatches(n), { props: A, attrs: E, cls: y, css: x, eventListeners: m } = e.$$consumeNextData(g);
      e.$$fulfillRef(d), e.$$fulfillPrimaryEl(d), e.$$updateDOMContent(d, l), d.addAttrs({ ...i, ...E }), d.addCls(y), d.addCss(x), c && d.addEventListeners(c), m.forEach((p) => d.addEventListeners(p)), e.$$pendingPatches = $;
      return;
    }
    return e.$app.contextFuncs[n].call(e.$lowlevel, t, ...s);
  }, e.$$t = (t, n) => {
    const s = String(n);
    let o = e.$$currentRefNode[t];
    o ? o.node.textContent !== s && (o.node.textContent = s) : (o = new I(document.createTextNode(s)), e.$$currentRefNode[t] = o), e.$$fulfillRef(o), e.$$currentDOMParent.pendingChildren.push(o);
  }, e.$$processComponent = (t, n, s, o) => {
    let i = e.$$currentRefNode[t];
    const l = e.$$currentRefNode;
    i || (i = new n(), l[t] = i), e.$$fulfillRef(i);
    const c = e.$$pendingPrimaryElOwner;
    e.$$pendingPrimaryElOwner = [];
    const d = e.$$pendingPatches, $ = e.$$fulfillPatches(o), { props: g, attrs: A, cls: E, css: y, eventListeners: x } = e.$$consumeNextData($);
    Object.assign(i, g), i.$primaryEl = void 0, e.$$pendingPrimaryElOwner.push(i), e.$$currentRefNode = i.$refTreeNode;
    let m;
    try {
      m = i.$main(...s);
    } catch (p) {
      e.$app.callHook("onError", p);
    }
    if (i.$primaryEl) {
      for (const h of c)
        h.$primaryEl ??= i.$primaryEl;
      e.$$pendingPrimaryElOwner = [];
      const p = i.$primaryEl;
      p.addAttrs(A), p.addCls(E), p.addCss(y), x.forEach((h) => p.addEventListeners(h));
    } else
      e.$$pendingPrimaryElOwner = c;
    return e.$$currentRefNode = l, e.$$pendingPatches = d, m;
  }, e.$$updateDOMContent = (t, n) => {
    const s = e.$$currentDOMParent, o = e.$$currentRefNode;
    if (s.pendingChildren.push(t), n !== void 0) {
      if (e.$$currentDOMParent = t, e.$$currentRefNode = t.$refTreeNode, typeof n == "function")
        try {
          n(e._);
        } catch (i) {
          e.$app.callHook("onError", i);
        }
      else
        e.$$t("_t", n);
      e.$$currentDOMParent = s, e.$$currentRefNode = o;
    }
  }, r.callHook("initContext", e);
}
const B = (r, e) => (
  /**
   * Use data from an async call when rendering.
   *
   * **Note**: Use `try`/`catch` to handle errors.
   *
   * @example
   * ```ts
   * if (_.$$c("[#[CKEY]#]", "await",() => fetch("https://example.com"))) {
   *   // When the promise is fulfilled, _.await returns true.
   *
   *   _.$$c("[#[CKEY]#]", "p",_.$awaited.statusText);
   *
   *   // You can also use a custom id for a nesting await call.
   *   _.$$c("[#[CKEY]#]", "await",() => _.$awaited.text(), "Text") && _.$$c("[#[CKEY]#]", "p",_.$awaitedText);
   * } else {
   *   // When the promise is pending, _.await returns false.
   *
   *   _.$$c("[#[CKEY]#]", "p","Loading...");
   * }
   * ```
   *
   * @param executor The async function to execute. This function is called only for once.
   * @param id The id of the await call. If not provided, the id is an empty string. Access the awaited data with `_.$awaited<id>`.
   * @throws The error thrown by the async function.
   */
  (t, n = "") => {
    const s = a.$lowlevel.$$currentRefNode;
    s[r] || (s[r] = {
      type: "pending"
    }, t().then((i) => {
      s[r] = {
        type: "fulfilled",
        value: i
      }, e.update();
    }).catch((i) => {
      s[r] = {
        type: "rejected",
        reason: i
      }, e.update();
    }));
    const o = s[r];
    if (o.type === "pending")
      return !1;
    if (o.type === "fulfilled")
      return a[`$awaited${n}`] = o.value, !0;
    throw o.reason;
  }
), Y = (r) => (
  /**
   * Set the document title.
   *
   * **Warning**: The document title will be overwritten by the last call to this function.
   */
  (e) => (a.$updateContext && (document.title = e), !0)
);
class W extends C {
  /**
   * Embed a content into the current output component.
   *
   * @param content The content to embed.
   * @param args The arguments to pass to the content, if the content is a view function.
   */
  $main(e, ...t) {
    if (typeof e == "function")
      try {
        e(...t.length === 0 ? [a] : t);
      } catch (n) {
        this.$app.callHook("onError", n);
      }
    else
      a.$lowlevel.$$t("_t", e);
  }
}
class G extends C {
  loadedContent = null;
  /**
   * Like `embed`, but the content is loaded asynchronously.
   *
   * @example
   * ```ts
   * _.$$c("[#[CKEY]#]", "asyncEmbed",() => import("./myView.ts"));
   * ```
   *
   * @param contentLoader A function that returns a promise of a object whose default export is a content.
   * @param args The arguments to pass to the content, if the content is a view function.
   */
  $main(e, ...t) {
    this.loadedContent ? a.$$c("[#[CKEY]#]", "embed", this.loadedContent, ...t) : e().then((n) => {
      this.loadedContent = n.default, this.$update();
    });
  }
}
function Z(r) {
  return typeof r == "function" ? r : (e) => `${e[r]}`;
}
const J = (r) => (
  /**
   * Loop over an iterable.
   *
   * **Warning**: **DO NOT** use `for` or `while` statement in Refina,
   *  which does not update $$currentRefNode,
   *  and will cause unexpected behavior.
   *  Use this function or `_.forTimes` instead.
   *
   * @param iterable The iterable to loop over.
   * @param key The key generator that generates a key for each item.
   * @param body The body of the loop.
   */
  (e, t, n) => {
    const s = a.$lowlevel, o = s.$$currentRefNode, i = o[r] ??= {}, l = Z(t);
    let c = 0;
    for (const d of e) {
      const $ = l(d, c).toString();
      i[$] ??= {}, s.$$currentRefNode = i[$], n(d, c), c++;
    }
    s.$$currentRefNode = o;
  }
), Q = (r) => (
  /**
   * Loop over a range of numbers. Similar to `for (let i = 0; i < times; i++)`.
   *
   * **Warning**: **DO NOT** use `for` or `while` statement in Refina,
   *  which does not update the $$currentRefNode,
   *  and will cause unexpected behavior.
   *  Use this function or `_.for` instead.
   *
   * **Warning**: **DO NOT** use this function to loop over an array,
   *  because the key of each item will just be the index of the item,
   *  which may cause unexpected behavior.
   *
   * @param times The number of times to loop.
   * @param body The body of the loop.
   */
  (e, t) => {
    const n = a.$lowlevel, s = n.$$currentRefNode, o = s[r] ??= {};
    for (let i = 0; i < e; i++) {
      const l = i.toString();
      o[l] ??= {}, n.$$currentRefNode = o[l], t(i);
    }
    n.$$currentRefNode = s;
  }
), ge = (r, e) => e, Ee = (r) => `${r}`, X = (r) => (
  /**
   * Render content to the end of the root element.
   *
   * This is usefull when you want to render a dialog or a tooltip
   *  that should not be affected by the parent element's styles.
   */
  (e) => {
    let t = a.$lowlevel.$$currentRefNode[r];
    t || (t = new q(a.$app.root.node), a.$lowlevel.$$currentRefNode[r] = t);
    const n = a.$updateContext?.$lowlevel;
    n ? (n.$$fulfillRef(t), n.$app.root.pendingPortals.push(t), n.$$updateDOMContent(t, e)) : a.$recvContext.$lowlevel.$$processDOMElement(r, e);
  }
), ee = (r) => (e, ...t) => {
  if (typeof e == "symbol") {
    const n = e, [s, o] = t, i = a.$runtimeData[n];
    a.$runtimeData[n] = s, a.$$c("[#[CKEY]#]", "embed", o, a), a.$runtimeData[n] = i;
  } else {
    const n = e, [s, ...o] = t, i = Object.getOwnPropertySymbols(n), l = {};
    for (const c of i)
      l[c] = a.$runtimeData[c], a.$runtimeData[c] = n[c];
    a.$$c("[#[CKEY]#]", "embed", s, ...o);
    for (const c of i)
      a.$runtimeData[c] = l[c];
  }
}, te = (r) => (
  /**
   * Get the current time in milliseconds.
   *
   * For every `precisionMs`, an `UPDATE` call will be scheduled to refresh the time.
   *
   * @param precisionMs The precision of the time in milliseconds.
   */
  (e = 1e3) => {
    const t = a.$lowlevel.$$currentRefNode;
    return a.$updateContext && !t[r] && (t[r] = !0, setTimeout(() => {
      delete t[r], a.$app.update();
    }, e)), Date.now();
  }
), ne = (r) => (
  /**
   * Schedule a callback to be called every `interval` milliseconds.
   */
  (e, t) => {
    const n = a.$lowlevel.$$currentRefNode;
    a.$updateContext && !n[r] && (n[r] = !0, setTimeout(() => {
      delete n[r], e(), a.$app.update();
    }, t));
  }
), re = (r) => (
  /**
   * Create a model.
   *
   * @param init The initial value.
   */
  (e) => {
    const t = a.$lowlevel.$$currentRefNode;
    return t[r] || (t[r] = H(e)), t[r];
  }
), se = {
  asyncEmbed: G,
  embed: W
}, oe = {
  await: B,
  documentTitle: Y,
  for: J,
  forTimes: Q,
  portal: X,
  provide: ee,
  now: te,
  setInterval: ne,
  useModel: re
}, ie = {
  name: "prelude",
  components: se,
  contextFuncs: oe,
  onError(r) {
    console.error(r);
  }
}, ae = [
  "initContext",
  "beforeMain",
  "afterMain",
  "beforeModifyDOM",
  "afterModifyDOM",
  "onError"
];
async function P(r) {
  return (await Promise.all(
    Array.isArray(r) ? r.map(P) : [r]
  )).flat().filter(Boolean);
}
async function le(r, e) {
  const t = [ie, ...await P(e)];
  for (const n of t) {
    if (n.onInstall?.(r), n.components)
      for (const [s, o] of Object.entries(n.components))
        r.contextFuncs[s] = b(s, o);
    if (n.contextFuncs)
      for (const [s, o] of Object.entries(n.contextFuncs))
        r.contextFuncs[s] = (i, ...l) => o(i, r)(...l);
    n.htmlElementAlias && Object.assign(r.htmlElementAlias, n.htmlElementAlias);
    for (const s of ae) {
      const o = n[s];
      o && r.pushPermanentHook(s, o);
    }
  }
}
class de {
  constructor(e, t) {
    this.main = t, Array.isArray(e) && (e = { plugins: e }), this.name = e.name, le(this, e.plugins ?? []);
    const n = e.root ?? "#app";
    if (typeof n == "string") {
      const s = document.querySelector(n);
      if (!s)
        throw new Error(`Root element ${n} not found.`);
      this.root = new R(s);
    } else
      this.root = new R(n);
  }
  name;
  plugins;
  /**
   * The map of context functions that are transformed, excluding HTML/SVG/Text element funcs.
   *
   * Context functions provided by plugins should be merged into this object.
   */
  contextFuncs = {};
  /**
   * The map of HTML element aliases.
   *
   * Most frequently used to process Web Components with slashes in their names.
   *
   * Plugins can add aliases to this map.
   */
  htmlElementAlias = {};
  /**
   * The root element component of the app.
   *
   * Initialized in the constructor depending on `rootElementId`.
   *
   * Call `app.root.addCls` or `app.root.addCss` to add classes or styles to the root element.
   */
  root;
  /**
   * The DOM element component of the document body.
   *
   * Call `app.body.addCls` or `app.body.addCss` to add classes or styles to the document body.
   */
  body = new U(document.body);
  /**
   * The DOM element component of the window.
   *
   * Call `app.window.addEventListener` to add event listeners to window.
   */
  window = new V(window);
  /**
   * Lifetime: from the construction of the app to the window is closed.
   */
  permanentData = {};
  /**
   * The state of the app.
   */
  state = u.IDLE;
  requireRecv;
  requireUpdate;
  /**
   * Mount the app to the root element.
   */
  mount() {
    this.requireUpdate = !0, this.execUpdate();
  }
  /**
   * Trigger an `UPDATE` call.
   */
  update = () => {
    this.requireUpdate = !0, this.state === u.IDLE && this.execUpdate();
  };
  /**
   * Trigger a `RECV` call.
   */
  recv = () => {
    if (this.requireRecv = !0, this.requireUpdate = !0, this.state === u.IDLE) {
      for (this.state = u.RECV; this.requireRecv; )
        this.requireRecv = !1, T(this), this.execMain();
      this.state = u.IDLE, this.execUpdate();
    } else if (this.state === u.RECV)
      this.requireRecv = !0;
    else if (this.state === u.UPDATE)
      throw new Error("Cannot call trigger recv in `UPDATE` state.");
  };
  execUpdate() {
    setTimeout(() => {
      this.requireUpdate && (this.state = u.UPDATE, K(this), this.execMain(), this.callHook("beforeModifyDOM"), this.window.updateDOM(), this.body.updateDOM(), this.root.updateDOM(), this.callHook("afterModifyDOM"), this.state = u.IDLE, this.requireUpdate = !1);
    });
  }
  /**
   * Execute the main function of the app in current state.
   */
  execMain() {
    try {
      this.callHook("beforeMain"), this.main(a), this.callHook("afterMain");
    } catch (e) {
      this.callHook("onError", e);
    }
  }
  /**
   * Lifecycle: removed after one call.
   */
  onetimeHooks = {};
  /**
   * Lifecycle: not removed after calls.
   */
  permanentHooks = {};
  /**
   * Promises that resolve after the corresponding hooks are called.
   */
  promises = {
    /**
     * Store the app instance, because `this` is lost in the getters.
     */
    app: this,
    /**
     * This promise resolves after the `beforeMain` hook is called.
     */
    get mainExecuted() {
      return new Promise((e) => {
        this.app.pushOnetimeHook("afterMain", e);
      });
    },
    /**
     * This promise resolves after the `beforeModifyDOM` hook is called.
     */
    get DOMUpdated() {
      return new Promise((e) => {
        this.app.pushOnetimeHook("afterModifyDOM", e);
      });
    }
  };
  /**
   * Call onetime hooks and reset them, then call permanent hooks.
   *
   * @param hookName the name of the hooks to call
   * @param args the arguments to pass to each hook
   */
  callHook(e, ...t) {
    const n = this.onetimeHooks[e];
    n && (this.onetimeHooks[e] = void 0, n.forEach((o) => o.apply(this, t)));
    const s = this.permanentHooks[e];
    s && s.forEach((o) => o.apply(this, t));
  }
  /**
   * Add a onetime hook to the end of the hook queue.
   *
   * @param hookName The name of the hook to push
   * @param hooks The hook to push
   */
  pushOnetimeHook(e, t) {
    this.onetimeHooks[e] ??= [], this.onetimeHooks[e].push(t);
  }
  /**
   * Add a permanent hook to the end of the hook queue.
   *
   * @param hookName
   * @param hooks
   */
  pushPermanentHook(e, ...t) {
    this.permanentHooks[e] ??= [], this.permanentHooks[e].push(...t);
  }
  /**
   * Set the value of a model and trigger an `UPDATE` call if the value is changed.
   *
   * @param model The model.
   * @param v The new value.
   * @returns Whether the value is changed.
   */
  updateModel = (e, t) => F(e, t) ? (this.update(), !0) : !1;
}
function ye(r, e) {
  const t = new de(r, e);
  return t.mount(), t;
}
export {
  ye as $app,
  ue as $contextFunc,
  ve as $view,
  de as App,
  u as AppState,
  C as Component,
  U as DOMBodyComponent,
  v as DOMElementComponent,
  O as DOMNodeComponent,
  q as DOMPortalComponent,
  R as DOMRootComponent,
  V as DOMWindowComponent,
  D as HTMLElementComponent,
  ie as Prelude,
  j as SVGElementComponent,
  I as TextNodeComponent,
  ce as TriggerComponent,
  a as _,
  ae as appHookNames,
  we as bindArgsToContent,
  ge as byIndex,
  Ee as bySelf,
  Ce as componentRef,
  L as createPatchTarget,
  F as dangerously_updateModel,
  me as elementRef,
  _ as emptyPatchTarget,
  M as initializeBaseContext,
  T as initializeRecvContext,
  K as initializeUpdateContext,
  le as installPlugins,
  pe as invalidateContext,
  N as isComponentCtor,
  S as isModel,
  k as mergeRefs,
  H as model,
  z as parseSelector,
  fe as propModel,
  he as ref,
  b as toComponentFunc,
  w as toModelValue,
  $e as unwrap
};
//# sourceMappingURL=index.js.map
