import { DOMElementEventListenersInfoRaw } from "../dom";
export interface PatchTarget<T = HTMLElement> {
    setProps(props: Partial<T>): this;
    setAttrs(attrs: Partial<T>): this;
    addCls(cls: string): this;
    resetCls(cls: string): this;
    addCss(css: string): this;
    resetCss(css: string): this;
    addEventListener<K extends keyof HTMLElementEventMap>(type: K, listener: (this: T, ev: HTMLElementEventMap[K]) => any, options?: boolean | AddEventListenerOptions): this;
    get patchData(): {
        props: Partial<T>;
        attrs: Partial<T>;
        resetCls: boolean;
        cls: string;
        resetCss: boolean;
        css: string;
        eventListeners: DOMElementEventListenersInfoRaw;
    };
}
export declare function createPatchTarget<T = HTMLElement>(): PatchTarget<T>;
export declare const emptyPatchTarget: PatchTarget<any>;
//# sourceMappingURL=patch.d.ts.map