import { AsyncEmbed, Embed } from "./embed";
/**
 * The plugin that is always installed on the app.
 */
export declare const Prelude: {
    name: string;
    components: {
        asyncEmbed: typeof AsyncEmbed;
        embed: typeof Embed;
    };
    contextFuncs: {
        await: import("..").ContextMemberFactory<(<T, N extends string | number = "">(executor: () => Promise<T>, id?: N) => this is Record<`$awaited${N}`, T>)>;
        documentTitle: import("..").ContextMemberFactory<(title: string) => true>;
        for: import("..").ContextMemberFactory<(<T = unknown>(iterable: Iterable<T>, key: import("./loop").LoopKey<T>, body: (item: T, index: number) => void) => void)>;
        forTimes: import("..").ContextMemberFactory<(times: number, body: (index: number) => void) => void>;
        portal: import("..").ContextMemberFactory<(children: import("..").Content) => void>;
        provide: import("..").ContextMemberFactory<{
            (key: symbol, value: unknown, content: import("..").Content): void;
            (obj: Record<symbol, unknown>, content: import("..").Content): void;
        }>;
        now: import("..").ContextMemberFactory<(precisionMs?: any) => number>;
        setInterval: import("..").ContextMemberFactory<(callback: () => void, interval: number) => void>;
        useModel: import("..").ContextMemberFactory<(<T_1>(init: T_1) => import("..").JustModel<T_1>)>;
    };
    onError(this: import("../app").App, error: unknown): void;
};
declare module ".." {
    interface Plugins {
        prelude: typeof Prelude;
    }
}
export type { AsyncContentLoader } from "./embed";
export { byIndex, bySelf, type LoopKey } from "./loop";
//# sourceMappingURL=index.d.ts.map